/* Header file for desktop switching program */

#pragma once

#include <Files.h>
#include <Folders.h>
#include <Aliases.h>
#include <AppleEvents.h>


#define LowerCase(c)			(((c) >= 'a' && (c) <= 'z') ? (c) - ('a' - 'A') : c)
#define LENGTH(s)	s[0]

#define myType 'APPL'
#define myCreator 'DTSW'
#define fNameLocked 0x1000
#define kDesktopFolder "\pDesktop Folder"
#define kDefaultFolderName "\pDesktopFiles"

#define kPrefsDialog_OK 1
#define kPrefsDialog_Cancel 2
#define kPrefsDialog_PutAway 3
#define kPrefsDialog_MakeInvisible 4
#define kPrefsDialog_MoveToFolder 5
#define kPrefsDialog_FolderButton 6
#define kPrefsDialog_FolderText 7
#define kPrefsDialog_MakeInvisWNF 8
#define kPrefsDialog_UI1 9
#define kPrefsDialog_UI2 10

#define kFolderNameDialog_OK 1
#define kFolderNameDialog_Cancel 2
#define kFolderNameDialog_Name 3

#define kPrefsID 128
#define kPrefsType 'dspr'

#define kPrefsDialogID 129
#define kGetFolderNameDialogID 128

typedef struct {
	Boolean PutAway, MakeInvis, MoveToFolder, MakeInvisWNF;
	Str31 folderName;
} PrefsStruct, *PrefsPtr, **PrefsHandle;

typedef struct {
	short aliasID;
	Point filePos;
} MyFInfoStruct;

typedef struct {
	short numFiles;
	AliasHandle theFiles[1];
}  FileList,*FileListPtr,**FileListHandle;

typedef struct {
	short numFiles;
	MyFInfoStruct fileList[1];
} FileListRsrc,*FileListRsrcPtr,**FileListRsrcHandle;

VCB *myVCBQHdr : 0x0358;

OSErr CreateDesktopFileList (FileListHandle *theDTFiles);
OSErr SaveDesktopFile (FSSpec theFile);
OSErr LoadDesktopFile (FSSpec theFile);
void HideItems(void);
OSErr CreateDTFileSet(void);
OSErr PutAwayItem (FSSpec theItem);
OSErr PutAwayAllItemsInFolder(short theVRefNum, long theDirID);
void UpdatePrefsDialogForSettings(DialogPtr theDialog);
void ConfigurePrefs (void);
void AskUserForDTFile(void);
void LoadPrefs (void);
void SavePrefs (void);
void AskUserForFolder(void);