\ Group2.ex

\ Example problem for use with LOGICA.
\ Copyright  1992, LogicLab.  All rights reserved.

\ Show that in group theory, a left identity is also a right identity.
\
Logic: Paramod;
function: f;         \ the group operation
function: Linv;						\ left inverse
constant: eL,a;      \ eL = the left identity element

\ The definition of left inverse and trivial equality
Axiom: 
equate(f(Linv(x),x),eL);
equate(x,x);

Assert:
\ Terminating condition:
\ "There is some element a for which eL isn't a right identity".
~equate(f(a,eL),a);
\ Definition of the left identity; it also appears below as a demodulator.
equate(f(eL,x),x);
\ It turns out that we have to either include associativity in the 
\ ASSERT list, or suppress the demodulator for f(Linv(x),x). We choose
\ the former: 
equate(f(f(x,x1),x2),f(x,f(x1,x2)));

Trivial:
equate(x,x);

\ demodulators: 
\ definitions of f(eL,x) and f(Linv(x),x)
Demodulate:
rewrite(f(eL,x),x);
rewrite(f(Linv(x),x),eL);


\ parameters
LimitF: 3;      \ limits number of function symbols
LimitV: 2;      \ limits number of distinct variables
LimitC: 2;      \ limits number of constant symbols


